diff -Naur --exclude=CVS --exclude=configs linux/include/linux/mfs.h linux-openmosix/include/linux/mfs.h
--- linux/include/linux/mfs.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/linux/mfs.h	2003-12-02 11:01:52.000000000 +0100
@@ -0,0 +1,491 @@
+#ifndef _MFS_H
+#define _MFS_H
+
+#include <linux/mfs_fs_i.h>
+
+#define	MFS_VERSION	2
+
+#define	MFS_GARBAGE_TIME (2700*HZ)
+#define	MFS_REPORT_TIME	(MFS_GARBAGE_TIME/3)
+
+#define	MFS_MAXBLOCK	16384
+
+/* test */
+
+extern int mfs_bh_statfs(mfs_handle_t, struct statfs *);
+
+ struct mfs_server_contact;
+struct mfs_client_contact; 
+
+struct mfs_completion
+{
+	unsigned char needed;
+	unsigned char done;
+	unsigned char func;
+	unsigned char ro;
+	int base_pe;
+	mfs_handle_t base;
+	mfs_handle_t dispose_base;
+	int other_pe;
+	mfs_handle_t other;
+	mfs_handle_t dispose_other;
+	union complete_args args;
+	void *more_data;
+	int more_data_len;
+	int error;
+};
+
+struct subinode
+{
+	unsigned long		si_ino;
+	unsigned int		si_count;
+	umode_t			si_mode;
+	nlink_t			si_nlink;
+	uid_t			si_iuid;
+	gid_t			si_gid;
+	kdev_t			si_rdev;
+	loff_t			si_size;
+	time_t			si_atime;
+	time_t			si_mtime;
+	time_t			si_ctime;
+	unsigned long		si_blksize;
+	unsigned long		si_blocks;
+	unsigned long		si_origino;
+	kdev_t			si_origdev;
+};
+
+struct mfs_dinfo
+{
+	int pe;
+	mfs_handle_t handle;
+	unsigned long latest;
+};
+
+extern int init_mfs(void);
+extern void mfs_change_pe(void);
+extern void mfs_change_root(struct dentry *, struct vfsmount *, struct dentry *, struct vfsmount *);
+extern int is_mfs_root(struct nameidata *);
+extern int mfs_walk_init_root(struct nameidata *);
+extern void mfs_ip_to_subip(struct subinode *, struct inode *);
+extern void mfs_subip_to_ip(struct inode *, struct subinode *);
+extern int mfs_conversion_init(void);
+extern mfs_handle_t local_to_mfs(struct nameidata *);
+extern int mfs_to_local(mfs_handle_t, struct nameidata *);
+extern int mfs_get_handle(mfs_handle_t handle);
+extern void mfs_put_handle(mfs_handle_t handle);
+extern int mfs_access_handle(mfs_handle_t handle);
+extern void mfs_lput(struct dentry *, struct vfsmount *);
+extern int mfs_try_to_cleanup(int);
+extern int mfs_attach_handle(int, mfs_handle_t);
+extern void mfs_dispose_handle(int, mfs_handle_t);
+extern int mfs_touch_handle(int, mfs_handle_t);
+extern ino_t global_inum(struct inode *);
+extern void cp_file_fields(struct file *, struct file *);
+
+extern loff_t mfs_low_llseek(mfs_handle_t, struct file *, loff_t, int);
+extern ssize_t mfs_low_read(mfs_handle_t, struct file *, char *, size_t, loff_t *);
+extern ssize_t mfs_low_write(mfs_handle_t, struct file *, char *, size_t, loff_t *, long);
+extern int mfs_low_open(mfs_handle_t, struct inode *, struct file *);
+extern int mfs_low_close(mfs_handle_t, struct inode *, struct file *);
+extern int mfs_low_readdir(mfs_handle_t, struct file *, void *, filldir_t, int *, int *);
+extern int mfs_low_ioctl(mfs_handle_t, struct file *, unsigned int, unsigned long, int, int *);
+extern int mfs_low_fsync(mfs_handle_t, struct file *, int);
+extern int mfs_low_attach_handle(mfs_handle_t);
+extern int mfs_low_touch_handle(mfs_handle_t);
+extern void mfs_low_dispose_handle(mfs_handle_t);
+extern int mfs_low_revalidate(mfs_handle_t, struct subinode *);
+extern int mfs_low_express_lookup(mfs_handle_t *, char *, unsigned int, int, int, struct subinode *, char **, struct mfs_completion *);
+extern int mfs_low_setattr(mfs_handle_t, struct iattr *);
+extern char *mfs_low_check_path(mfs_handle_t);
+
+extern void mfs_prepare_completion(struct mfs_completion *, struct nameidata *);
+extern int mfs_check_completion(struct mfs_completion *, struct nameidata *);
+extern mfs_handle_t mfs_low_complete(struct mfs_completion *, struct nameidata *);
+extern void mfs_low_complete_error(struct mfs_completion *, int);
+extern int mfs_link_complete(struct mfs_completion *, int, struct nameidata *);
+
+extern struct dentry *mfs_root;
+extern struct vfsmount *mfs_mnt;
+extern ino_t mfs_root_ino;
+extern dev_t mfs_root_dev;
+extern struct super_block *mfs_super;
+extern int MFS_PE;
+extern int mfs_debug;
+extern char mfs_is_ro;
+#ifdef CONFIG_MOSIX_DFSA
+extern char mfs_is_dfsa;
+#endif /* CONFIG_MOSIX_DFSA */
+
+#define	MFS_SUPER_MAGIC	235466776
+#define	MFS_BAD_PE	65536
+#define	MFS_UNKNOWN_PE	65537
+#define	MFS_ROOT_INO	65538
+
+/* protocols: */
+
+enum
+{
+	MFS_NONE = 0,
+	MFS_CLOSE,
+	MFS_CONTINUE,
+	MFS_STOP,
+	MFS_INTERIM_DATA,
+	MFS_REQUEST_LLSEEK,
+	MFS_REPLY_LLSEEK,
+	MFS_REQUEST_READ,
+	MFS_REPLY_READ,
+	MFS_REQUEST_WRITE,
+	MFS_REPLY_WRITE,
+	MFS_REQUEST_OPEN,
+	MFS_REPLY_OPEN,
+	MFS_REQUEST_CLOSE,
+	MFS_REPLY_CLOSE,
+	MFS_REQUEST_READDIR,
+	MFS_INTERIM_READDIR,
+	MFS_REPLY_READDIR,
+	MFS_REQUEST_IOCTL,
+	MFS_REPLY_IOCTL,
+	MFS_REQUEST_FSYNC,
+	MFS_REPLY_FSYNC,
+	MFS_REQUEST_REVALIDATE,
+	MFS_REPLY_REVALIDATE,
+	MFS_REQUEST_EXPRESS,
+	MFS_REPLY_EXPRESS,
+	MFS_REQUEST_CHECKPATH,
+	MFS_REPLY_CHECKPATH,
+	MFS_REQUEST_SETATTR,
+	MFS_REPLY_SETATTR,
+	MFS_REQUEST_ATTACH_HANDLE,
+	MFS_REPLY_ATTACH_HANDLE,
+	MFS_REQUEST_TOUCH_HANDLE,
+	MFS_REPLY_TOUCH_HANDLE,
+	MFS_REQUEST_DISPOSE_HANDLE,
+	MFS_REQUEST_STATFS,
+	MFS_REPLY_STATFS,
+};
+struct mfs_cred
+{
+	        uid_t uid, euid, suid, fsuid;
+	        gid_t gid, egid, sgid, fsgid;
+	        int ngroups;
+	        gid_t groups[NGROUPS];
+	        kernel_cap_t caps;
+	        int whereami;
+	        int deppe;
+};
+struct mfs_request_statfs
+{
+	        struct mfs_cred cred;
+	        mfs_handle_t handle;
+};
+
+struct mfs_reply_statfs
+{
+	        struct statfs stat;
+	        loff_t result;
+};
+struct mfs_request_llseek
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+	struct file file;
+	loff_t offset;
+	int origin;
+};
+
+
+struct mfs_reply_llseek
+{
+	struct file file;
+	int result;
+};
+
+struct mfs_request_read
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+	struct file file;
+	size_t count;
+	loff_t pos;
+};
+
+struct mfs_interim_data
+{
+	size_t count;
+};
+
+struct mfs_reply_read
+{
+	struct file file;
+	loff_t ppos;
+	ssize_t result;
+	size_t datalen;
+};
+
+struct mfs_request_write
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+	struct file file;
+	size_t count;
+	loff_t pos;
+	size_t datalen;
+	long flim;
+};
+
+struct mfs_reply_write
+{
+	struct file file;
+	loff_t ppos;
+	ssize_t result;
+	int hadsigxfsz;
+};
+
+struct mfs_request_readdir
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+	struct file file;
+	int policy;
+	int maxbytes;
+};
+
+#define	MFS_READDIR_UNKNOWN	0
+#define	MFS_READDIR_JUSTONE	1
+#define	MFS_READDIR_GETDENTS	2
+#define	MFS_READDIR_GETDENTS64	3
+
+struct mfs_interim_readdir
+{
+	int error;
+};
+
+struct mfs_reply_readdir
+{
+	struct file file;
+	int result;
+	int datalen;
+};
+
+struct mfs_request_ioctl
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+	struct file file;
+	unsigned int cmd;
+	unsigned long arg;
+	int data;
+	int size;
+};
+
+struct mfs_reply_ioctl
+{
+	struct file file;
+	int data;
+	int result;
+};
+
+struct mfs_request_open
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+	struct file file;
+	struct inode inode;
+};
+
+struct mfs_reply_open
+{
+	struct file file;
+	struct inode inode;
+	int result;
+};
+
+struct mfs_request_fsync
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+	struct file file;
+	int datasync;
+};
+
+struct mfs_reply_fsync
+{
+	struct file file;
+	int result;
+};
+
+struct mfs_request_revalidate
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+};
+
+struct mfs_reply_revalidate
+{
+	struct subinode iinfo;
+	int result;
+};
+
+struct mfs_request_express
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+	int namelen;
+	unsigned int follow;
+	int link_count;
+	int total_link_count;
+	struct mfs_completion complete;
+};
+
+struct mfs_reply_express
+{
+	mfs_handle_t handle;
+	struct subinode iinfo;
+	int namelen;
+	struct mfs_completion complete;
+	int result;
+};
+
+struct mfs_request_checkpath
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+};
+
+struct mfs_reply_checkpath
+{
+	int namelen;
+};
+
+struct mfs_request_setattr
+{
+	struct mfs_cred cred;
+	mfs_handle_t handle;
+	struct iattr attr;
+};
+
+struct mfs_reply_setattr
+{
+	int result;
+};
+
+struct mfs_request_attach_handle
+{
+	mfs_handle_t handle;
+};
+
+struct mfs_reply_attach_handle
+{
+	int result;
+};
+
+struct mfs_request_touch_handle
+{
+	mfs_handle_t handle;
+};
+
+struct mfs_reply_touch_handle
+{
+	int result;
+};
+
+struct mfs_request_dispose_handle
+{
+	mfs_handle_t handle;
+};
+
+struct mfs_server_contact *mfs_alloc_service(void);
+void mfs_release_contact(struct mfs_client_contact *);
+int mfs_client_contact_has_data(struct mfs_client_contact *);
+void mfs_end_serve(struct mfs_server_contact *);
+int mfs_server_send(struct mfs_server_contact *, int, void *, int, void *, int, void *, int);
+int mfs_client_send(struct mfs_client_contact *, int, void *, int, void *, int, void *, int);
+int mfs_server_receive(struct mfs_server_contact *, void **, void **, void **);
+int mfs_client_receive(struct mfs_client_contact *, void **, void **, void **);
+struct mfs_client_contact *mfs_new_request(int, int, void *, int, void *, int, void *, int);
+void mfs_make_servers(void);
+void mfs_new_request_arrived(void);
+void mfs_serve(struct mfs_server_contact *, int, void *, void *, void *);
+
+int mfs_client_attach_handle(int, mfs_handle_t);
+void mfs_client_dispose_handle(int, mfs_handle_t);
+int mfs_client_touch_handle(int, mfs_handle_t);
+int mfs_client_open(int, mfs_handle_t, struct inode *, struct file *);
+int mfs_client_close(int, mfs_handle_t, struct inode *, struct file *);
+int mfs_client_llseek(int, mfs_handle_t, struct file *, loff_t, int);
+ssize_t mfs_client_read(int, mfs_handle_t, struct file *, char *, size_t, loff_t *);
+ssize_t mfs_client_write(int, mfs_handle_t, struct file *, char *, size_t, loff_t *, long);
+int mfs_client_readdir(int, mfs_handle_t, struct file *, void *, filldir_t, int, int, int *, int *);
+int mfs_client_ioctl(int, mfs_handle_t, struct file *, unsigned int, unsigned long, int, int *);
+int mfs_client_fsync(int, mfs_handle_t, struct file *, int);
+int mfs_client_revalidate(int, mfs_handle_t, struct subinode *);
+int mfs_client_express_lookup(int, mfs_handle_t *, char *, unsigned int, struct subinode *, char **, struct mfs_completion *);
+char *mfs_client_check_path(int, mfs_handle_t);
+int mfs_client_setattr(int, mfs_handle_t, struct iattr *);
+void mfs_throw_garbage(void);
+int mfs_client_daemon(void *);
+int mfs_kill(char *);
+void mfs_tuneinfo(char *);
+#ifdef CONFIG_MOSIX_DFSA
+int mfs_add_stats(struct mfs_stats *, struct mfs_stats *, struct mosix_task *);
+#else
+static inline int mfs_add_stats(struct mfs_stats *x, struct mfs_stats *y, struct mosix_task *z)
+{
+	return(0);
+}
+#endif /* CONFIG_MOSIX_DFSA */
+
+extern struct task_struct *mfs_main_server_task;
+
+static inline int
+file_is_mfs(struct file *file)
+{
+	struct dentry *dp;
+	struct inode *ip;
+	struct super_block *sb;
+
+	return(file && (dp = file->f_dentry) && (ip = dp->d_inode) &&
+		(sb = ip->i_sb) && sb->s_magic == MFS_SUPER_MAGIC);
+}
+
+/* statistic collection: */
+
+#ifdef CONFIG_MOSIX_DFSA
+extern void mfs_count(int, int, int);
+
+#define	mfs_count_attach_handle(w)	mfs_count(w, 0, 0)
+#define	mfs_count_touch_handle(w)	mfs_count(w, 0, 0)
+#define	mfs_count_dispose_handle(w)	mfs_count(w, 0, 0)
+#define	mfs_count_llseek(w)		mfs_count(w, 0, 0)
+#define	mfs_count_read(w,n)		mfs_count(w, n, 0)
+#define	mfs_count_write(w,n)		mfs_count(w, 0, n)
+#define	mfs_count_readdir(w,p,b)	mfs_count(w, b, (p) * sizeof(int))
+#define	mfs_count_ioctl(w)		mfs_count(w, 0, 0)
+#define	mfs_count_open(w)		mfs_count(w, 0, 0)
+#define	mfs_count_fsync(w)		mfs_count(w, 0, 0)
+#define	mfs_count_setattr(w)		mfs_count(w, 0, 0)
+#define	mfs_count_revalidate(w)		mfs_count(w, 0, 0)
+#define	mfs_count_express(w,l) 		mfs_count(w, 0, l)
+#define	mfs_count_check_path(w,l)	mfs_count(w, 0, l)
+#define	mfs_count_notify_change(w)	mfs_count(w, 0, 0)
+#define mfs_count_statfs(w)             mfs_count(w, 0, 0)
+#else
+#define	mfs_count_attach_handle(w)	do {} while(0)
+#define	mfs_count_touch_handle(w)	do {} while(0)
+#define	mfs_count_dispose_handle(w)	do {} while(0)
+#define	mfs_count_llseek(w)		do {} while(0)
+#define	mfs_count_read(w,n)		do {} while(0)
+#define	mfs_count_write(w,n)		do {} while(0)
+#define	mfs_count_readdir(w,p,b)	do {} while(0)
+#define	mfs_count_ioctl(w)		do {} while(0)
+#define	mfs_count_open(w)		do {} while(0)
+#define	mfs_count_fsync(w)		do {} while(0)
+#define	mfs_count_setattr(w)		do {} while(0)
+#define	mfs_count_revalidate(w)		do {} while(0)
+#define	mfs_count_express(w,l)	do {} while(0)
+#define	mfs_count_check_path(w,l)	do {} while(0)
+#define	mfs_count_notify_change(w)	do {} while(0)A
+#define mfs_count_statfs(w) 		do {} while(0)
+#endif /* CONFIG_MOSIX_DFSA */
+
+#endif /* _MFS_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/mfs_socket.h linux-openmosix/include/linux/mfs_socket.h
--- linux/include/linux/mfs_socket.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/linux/mfs_socket.h	2002-02-14 11:35:25.000000000 +0100
@@ -0,0 +1,40 @@
+#ifndef _MFS_SOCKET_H
+#define _MFS_SOCKET_H
+
+struct socket;
+
+struct mfs_message_header
+{
+	char version;
+	char first;
+	short hdsz;
+	int caller;
+	int serial;
+	int type;
+	int dat1sz;
+	int dat2sz;
+};
+
+struct socket *mfs_open_main_socket(void);
+struct socket *mfs_new_connection(struct socket *, int *);
+struct socket *mfs_connect_to(int);
+int mfs_socket_has_data(struct socket *);
+int mfs_socket_is_closed(struct socket *);
+int mfs_send(struct socket *, int, int, int, void *, int, void *, int, void *, int);
+int mfs_receive(struct socket *, int, int *, struct mfs_message_header *, void **, void **, void **);
+int mfs_set_main_ownership(struct socket *, int);
+void mfs_close_socket(struct socket *);
+void mfs_monitor_client_contacts(void);
+
+/* 2nd parameter of mfs_receive: */
+enum
+{
+	MFS_FIRST_RECEIVE,	/* obtain serial */
+	MFS_MUST_MATCH,		/* fail if serial does not match */
+	MFS_SKIP_OTHERS,	/* skip packet if serial does not match */
+	MFS_JUST_HEADER		/* preliminary header check */
+};
+
+#define	MFS_MAIN_PORT	0xD302
+
+#endif /* _MFS__SOCKET_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/mman.h linux-openmosix/include/linux/mman.h
--- linux/include/linux/mman.h	2000-03-15 03:21:56.000000000 +0100
+++ linux-openmosix/include/linux/mman.h	2004-02-05 10:51:27.000000000 +0100
@@ -6,4 +6,7 @@
 #define MREMAP_MAYMOVE	1
 #define MREMAP_FIXED	2
 
+extern int vm_enough_memory(long pages);
+extern void vm_unacct_vma(struct vm_area_struct *vma);
+
 #endif /* _LINUX_MMAN_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/mm.h linux-openmosix/include/linux/mm.h
--- linux/include/linux/mm.h	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/include/linux/mm.h	2004-02-05 10:51:27.000000000 +0100
@@ -103,9 +103,10 @@
 #define VM_DONTCOPY	0x00020000      /* Do not copy this vma on fork */
 #define VM_DONTEXPAND	0x00040000	/* Cannot expand with mremap() */
 #define VM_RESERVED	0x00080000	/* Don't unmap it from swap_out */
+#define VM_ACCOUNT	0x00100000	/* Is a VM accounted object */
 
 #ifndef VM_STACK_FLAGS
-#define VM_STACK_FLAGS	0x00000177
+#define VM_STACK_FLAGS	(0x00000177 | VM_ACCOUNT)
 #endif
 
 #define VM_READHINTMASK			(VM_SEQ_READ | VM_RAND_READ)
@@ -179,6 +180,10 @@
 	void *virtual;			/* Kernel virtual address (NULL if
 					   not kmapped, ie. highmem) */
 #endif /* CONFIG_HIGMEM || WANT_PAGE_VIRTUAL */
+#ifdef CONFIG_MOSIX
+	char young;
+	unsigned long last_young;
+#endif /* CONFIG_MOSIX */
 } mem_map_t;
 
 /*
@@ -589,6 +594,48 @@
 		return 0;
 }
 
+#ifdef CONFIG_MOSIX
+static inline unsigned long
+do_mmap_pgoff_down(struct file *file, unsigned long addr, unsigned long len,
+	unsigned long prot, unsigned long flag, unsigned long pgoff)
+{
+	int initially_local = !(current->mosix.dflags & DDEPUTY);
+	struct mm_struct *mm = current->mm;
+	unsigned long result;
+
+	if(initially_local)
+	{
+		down_write(&mm->mmap_sem);
+#ifdef CONFIG_MOSIX_FS
+		current->mosix.dirty_bits |= MMAP_MMDOWNED;
+#endif /* CONFIG_MOSIX_FS */
+	}
+	result = do_mmap_pgoff(file, addr, len, prot, flag, pgoff);
+	if(initially_local)
+	{
+		up_write(&mm->mmap_sem);
+#ifdef CONFIG_MOSIX_FS
+		current->mosix.dirty_bits &= ~MMAP_MMDOWNED;
+#endif /* CONFIG_MOSIX_FS */
+	}
+	return(result);
+}
+
+static inline unsigned long do_mmap_down(struct file *file, unsigned long addr,
+	unsigned long len, unsigned long prot,
+	unsigned long flag, unsigned long offset)
+{
+	unsigned long ret = -EINVAL;
+	if ((offset + PAGE_ALIGN(len)) < offset)
+		goto out;
+	if (!(offset & ~PAGE_MASK))
+		ret = do_mmap_pgoff_down(file, addr, len, prot, flag, offset >> PAGE_SHIFT);
+out:
+	return ret;
+}
+
+#endif /* CONFIG_MOSIX */
+
 struct zone_t;
 /* filemap.c */
 extern void remove_inode_page(struct page *);
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/mount.h linux-openmosix/include/linux/mount.h
--- linux/include/linux/mount.h	2001-10-05 22:05:55.000000000 +0200
+++ linux-openmosix/include/linux/mount.h	2004-02-05 10:51:27.000000000 +0100
@@ -29,6 +29,11 @@
 	int mnt_flags;
 	char *mnt_devname;		/* Name of device e.g. /dev/dsk/hda1 */
 	struct list_head mnt_list;
+#ifdef CONFIG_MOSIX_DFSA
+	short mnt_dfsa;		/* what should be */
+	short mnt_dfsano;	/* what is */
+	short mnt_dfsaprev;	/* what was */
+#endif /* CONFIG_MOSIX_DFSA */
 };
 
 static inline struct vfsmount *mntget(struct vfsmount *mnt)
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/net.h linux-openmosix/include/linux/net.h
--- linux/include/linux/net.h	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/include/linux/net.h	2004-02-05 10:51:27.000000000 +0100
@@ -62,6 +62,12 @@
 #define SOCK_ASYNC_WAITDATA	1
 #define SOCK_NOSPACE		2
 
+#ifdef CONFIG_MOSIX
+#define SOCK_INTER_MOSIX	3	/* used internally in kernel-mode */
+#define	SOCK_WAIT_MFSDATA	4	/* waiting for MFS data */
+#define	SOCK_OOB_IN		5	/* OOB received on MOSIX socket */
+#endif /* CONFIG_MOSIX */
+
 struct socket
 {
 	socket_state		state;
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/personality.h linux-openmosix/include/linux/personality.h
--- linux/include/linux/personality.h	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/include/linux/personality.h	2004-02-05 10:51:27.000000000 +0100
@@ -127,4 +127,8 @@
 		__MOD_DEC_USE_COUNT(ep->module);	\
 } while (0)
 
+#ifdef CONFIG_MOSIX
+extern struct exec_domain *lookup_exec_domain(unsigned long);
+#endif /* CONFIG_MOSIX */
+
 #endif /* _LINUX_PERSONALITY_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/pipe_fs_i.h linux-openmosix/include/linux/pipe_fs_i.h
--- linux/include/linux/pipe_fs_i.h	2001-04-25 23:18:23.000000000 +0200
+++ linux-openmosix/include/linux/pipe_fs_i.h	2004-02-05 10:51:27.000000000 +0100
@@ -9,6 +9,10 @@
 	unsigned int start;
 	unsigned int readers;
 	unsigned int writers;
+#ifdef CONFIG_MOSIX_PIPE_EXCEPTIONS
+	unsigned int exceptions;
+	unsigned long reading_bytes;
+#endif /* CONFIG_MOSIX_PIPE_EXCEPTIONS */
 	unsigned int waiting_readers;
 	unsigned int waiting_writers;
 	unsigned int r_counter;
@@ -38,6 +42,14 @@
 #define PIPE_MAX_RCHUNK(inode)	(PIPE_SIZE - PIPE_START(inode))
 #define PIPE_MAX_WCHUNK(inode)	(PIPE_SIZE - PIPE_END(inode))
 
+#ifdef CONFIG_MOSIX_PIPE_EXCEPTIONS
+#define	PIPE_EXCEPTIONS(inode)	((inode).i_pipe->exceptions)
+#define	PIPE_READING_BYTES(inode)	((inode).i_pipe->reading_bytes)
+
+#define	PIPE_EXCEPTION_INPUT	1
+#define	PIPE_EXCEPTION_NOINPUT	2
+#endif /* CONFIG_MOSIX_PIPE_EXCEPTIONS */
+
 /* Drop the inode semaphore and wait for a pipe event, atomically */
 void pipe_wait(struct inode * inode);
 
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/proc_fs.h linux-openmosix/include/linux/proc_fs.h
--- linux/include/linux/proc_fs.h	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/include/linux/proc_fs.h	2004-02-05 10:51:27.000000000 +0100
@@ -90,6 +90,9 @@
 void proc_pid_delete_inode(struct inode *inode);
 int proc_pid_readdir(struct file * filp, void * dirent, filldir_t filldir);
 
+#ifdef CONFIG_MOSIX
+extern int proc_register(struct proc_dir_entry *, struct proc_dir_entry *);
+#endif /* CONFIG_MOSIX */
 extern struct proc_dir_entry *create_proc_entry(const char *name, mode_t mode,
 						struct proc_dir_entry *parent);
 extern void remove_proc_entry(const char *name, struct proc_dir_entry *parent);
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/remote_fs_i.h linux-openmosix/include/linux/remote_fs_i.h
--- linux/include/linux/remote_fs_i.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/linux/remote_fs_i.h	2002-02-14 11:35:25.000000000 +0100
@@ -0,0 +1,32 @@
+/*
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Amnon Shiloh.
+ */
+#ifndef _LINUX_REMOTE_FS_I_H
+#define _LINUX_REMOTE_FS_I_H
+#ifdef CONFIG_MOSIX
+
+struct vm_area_struct;
+typedef struct page * (*nopage_t)(struct vm_area_struct *, unsigned long, int);
+
+struct remote_inode_info
+{
+	int origin;			/* node of origin */
+	struct dentry *dp;		/* dentry pointer on origin */
+	uint64_t unique;		/* unique version on origin */
+	nopage_t nopage;		/* nopage routine */
+};
+
+#define	home_file(f)	(*((struct file **)(&(f)->f_pos)))
+
+#endif /* CONFIG_MOSIX */
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/sched.h linux-openmosix/include/linux/sched.h
--- linux/include/linux/sched.h	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/include/linux/sched.h	2004-02-05 10:51:27.000000000 +0100
@@ -29,6 +29,12 @@
 
 struct exec_domain;
 
+#ifdef CONFIG_MOSIX
+#include <hpc/hpctask.h>
+#else
+#define MOSIX_INIT_TASK(tsk)
+#endif /* CONFIG_MOSIX */
+
 /*
  * cloning flags:
  */
@@ -91,6 +97,9 @@
 #define TASK_UNINTERRUPTIBLE	2
 #define TASK_ZOMBIE		4
 #define TASK_STOPPED		8
+#ifdef CONFIG_MOSIX
+#define	TASK_SAME		16
+#endif /* CONFIG_MOSIX */
 
 #define __set_task_state(tsk, state_value)		\
 	do { (tsk)->state = (state_value); } while (0)
@@ -181,6 +190,25 @@
 	fd_set close_on_exec_init;
 	fd_set open_fds_init;
 	struct file * fd_array[NR_OPEN_DEFAULT];
+#ifdef CONFIG_MOSIX_DFSA
+	atomic_t users;		/* the real count, excluding /proc grabs */
+	int count_dropped_to_one;
+	int maxclosed;
+	fd_set *closed;
+	fd_set closed_fds_init;
+	int maxopened;
+	fd_set *opened;
+	fd_set opened_fds_init;
+	int maxmod;
+	fd_set *modified;
+	fd_set modified_fds_init;
+#define	INIT_FILES_DFSA , users : ATOMIC_INIT(1), \
+			  closed: &init_files.closed_fds_init, \
+			  opened: &init_files.opened_fds_init, \
+			  modified: &init_files.modified_fds_init,
+#else
+#define	INIT_FILES_DFSA
+#endif /* CONFIG_MOSIX_DFSA */
 };
 
 #define INIT_FILES \
@@ -196,6 +224,7 @@
 	close_on_exec_init: { { 0, } }, 		\
 	open_fds_init:	{ { 0, } }, 			\
 	fd_array:	{ NULL, } 			\
+	INIT_FILES_DFSA					\
 }
 
 /* Maximum number of active map areas.. This is a random (large) number */
@@ -231,8 +260,23 @@
 
 	/* Architecture-specific MM context */
 	mm_context_t context;
+#ifdef CONFIG_MOSIX
+	atomic_t mm_kiocount;
+	atomic_t mm_realusers;
+	unsigned long last_memsort;
+	int used, unused, swapped;	/* break-down of memory pages */
+	int private_unused;		/* unused but not active/inactive */
+/*
+	int private_unused;
+*/
+	int mark;
 };
 
+#define	INIT_MM_MOSIX	mm_kiocount: ATOMIC_INIT(0), mm_realusers: ATOMIC_INIT(1),
+#else
+#define	INIT_MM_MOSIX
+#endif /* CONFIG_MOSIX */
+
 extern int mmlist_nr;
 
 #define INIT_MM(name) \
@@ -244,6 +288,7 @@
 	mmap_sem:	__RWSEM_INITIALIZER(name.mmap_sem), \
 	page_table_lock: SPIN_LOCK_UNLOCKED, 		\
 	mmlist:		LIST_HEAD_INIT(name.mmlist),	\
+	INIT_MM_MOSIX					\
 }
 
 struct signal_struct {
@@ -343,9 +388,9 @@
 	pid_t tgid;
 	/* boolean value for session group leader */
 	int leader;
-	/* 
+	/*
 	 * pointers to (original) parent process, youngest child, younger sibling,
-	 * older sibling, respectively.  (p->father can be replaced with 
+	 * older sibling, respectively.  (p->father can be replaced with
 	 * p->p_pptr->pid)
 	 */
 	struct task_struct *p_opptr, *p_pptr, *p_cptr, *p_ysptr, *p_osptr;
@@ -406,13 +451,15 @@
 	int (*notifier)(void *priv);
 	void *notifier_data;
 	sigset_t *notifier_mask;
-	
+
 /* Thread group tracking */
    	u32 parent_exec_id;
    	u32 self_exec_id;
 /* Protection of (de-)allocation: mm, files, fs, tty */
 	spinlock_t alloc_lock;
-
+#ifdef CONFIG_MOSIX
+	struct mosix_task mosix;
+#endif /* CONFIG_MOSIX */
 /* journalling filesystem info */
 	void *journal_info;
 };
@@ -508,6 +555,7 @@
     blocked:		{{0}},						\
     alloc_lock:		SPIN_LOCK_UNLOCKED,				\
     journal_info:	NULL,						\
+MOSIX_INIT_TASK(tsk)                            \
 }
 
 
@@ -554,9 +602,23 @@
 
 	for(p = *htable; p && p->pid != pid; p = p->pidhash_next)
 		;
+#ifdef CONFIG_MOSIX
+	if(p && (p->mosix.dflags & DREMOTE))
+		p = NULL;
+#endif /* CONFIG_MOSIX */
+	return p;
+}
 
+#ifdef CONFIG_MOSIX
+static inline struct task_struct *find_any_task_by_pid(int pid)
+{
+	struct task_struct *p, **htable = &pidhash[pid_hashfn(pid)];
+
+	for(p = *htable; p && p->pid != pid; p = p->pidhash_next)
+		;
 	return p;
 }
+#endif /* CONFIG_MOSIX */
 
 #define task_has_cpu(tsk) ((tsk)->cpus_runnable != ~0UL)
 
@@ -679,6 +741,14 @@
 
 static inline void recalc_sigpending(struct task_struct *t)
 {
+#ifdef CONFIG_MOSIX
+	t->mosix.ignoreoldsigs = 0;
+	if(t->mosix.dflags & DHEAVYSLEEP)
+		t->sigpending = 0;
+	else if(t->mosix.dflags & DFAKESIGNAL)
+		t->sigpending = 1;
+	else
+#endif /* CONFIG_MOSIX */
 	t->sigpending = has_pending_signals(&t->pending.signal, &t->blocked);
 }
 
@@ -711,12 +781,12 @@
  * fsuser(). This is done, along with moving fsuser() checks to be
  * last.
  *
- * These will be removed, but in the mean time, when the SECURE_NOROOT 
+ * These will be removed, but in the mean time, when the SECURE_NOROOT
  * flag is set, uids don't grant privilege.
  */
 static inline int suser(void)
 {
-	if (!issecure(SECURE_NOROOT) && current->euid == 0) { 
+	if (!issecure(SECURE_NOROOT) && current->euid == 0) {
 		current->flags |= PF_SUPERPRIV;
 		return 1;
 	}
@@ -733,7 +803,7 @@
 }
 
 /*
- * capable() checks for a particular capability.  
+ * capable() checks for a particular capability.
  * New privilege checks should use this interface, rather than suser() or
  * fsuser(). See include/linux/capability.h for defined capabilities.
  */
@@ -803,6 +873,9 @@
 extern void FASTCALL(remove_wait_queue(wait_queue_head_t *q, wait_queue_t * wait));
 
 extern long kernel_thread(int (*fn)(void *), void * arg, unsigned long flags);
+#ifdef CONFIG_MOSIX
+extern long user_thread(int (*fn)(void *), void * arg, unsigned long flags);
+#endif /* CONFIG_MOSIX */
 
 #define __wait_event(wq, condition) 					\
 do {									\
@@ -847,7 +920,7 @@
 	current->state = TASK_RUNNING;					\
 	remove_wait_queue(&wq, &__wait);				\
 } while (0)
-	
+
 #define wait_event_interruptible(wq, condition)				\
 ({									\
 	int __ret = 0;							\
@@ -889,10 +962,41 @@
 
 #define thread_group_leader(p)	(p->pid == p->tgid)
 
+#ifdef CONFIG_MOSIX
+#define for_each_local_task(p) \
+	for (p = &init_task ; (p = p->next_task) != &init_task ; ) \
+	if(!(p->mosix.dflags & DREMOTE))
+
+static inline long
+LOGICAL_STATE(struct task_struct *p)
+{
+	int result;
+	unsigned long flags;
+
+	read_lock_irqsave(&p->mosix.state_lock, flags);
+	result = (p->mosix.bstate == TASK_SAME) ? p->state : p->mosix.bstate;
+	read_unlock_irqrestore(&p->mosix.state_lock, flags);
+	return(result);
+}
+
+extern void run_on(struct task_struct *);
+extern void run_off(struct task_struct *);
+
+#define	need_interim_while_asleep()	mosix_need_while_asleep()
+#define	run_interim_while_asleep()	mosix_run_while_asleep()
+#endif /* CONFIG_MOSIX */
+
+#ifndef CONFIG_MOSIX
+#define LOGICAL_STATE(p)	(p->state)
+#endif /* !CONFIG_MOSIX */
+
 static inline void del_from_runqueue(struct task_struct * p)
 {
 	nr_running--;
 	p->sleep_time = jiffies;
+#ifdef CONFIG_MOSIX
+	run_off(p);
+#endif /* CONFIG_MOSIX */
 	list_del(&p->run_list);
 	p->run_list.next = NULL;
 }
@@ -932,6 +1036,11 @@
 	char *res;
 	struct vfsmount *rootmnt;
 	struct dentry *root;
+#if defined(CONFIG_MOSIX_DFSA) || defined(CONFIG_MOSIX_FS)
+	if(dentry->d_inode && dentry->d_inode->i_op &&
+		dentry->d_inode->i_op->check_path)
+		dentry->d_inode->i_op->check_path(dentry);
+#endif /* CONFIG_MOSIX_DFSA || CONFIG_MOSIX_FS */
 	read_lock(&current->fs->lock);
 	rootmnt = mntget(current->fs->rootmnt);
 	root = dget(current->fs->root);
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/smp_lock.h linux-openmosix/include/linux/smp_lock.h
--- linux/include/linux/smp_lock.h	2001-11-22 20:46:27.000000000 +0100
+++ linux-openmosix/include/linux/smp_lock.h	2004-02-05 10:51:27.000000000 +0100
@@ -11,6 +11,11 @@
 #define reacquire_kernel_lock(task)		do { } while(0)
 #define kernel_locked() 1
 
+#ifdef CONFIG_MOSIX
+#define	lock_mosix()				do {} while(0)
+#define	unlock_mosix()				do {} while(0)
+#endif /* CONFIG_MOSIX */
+
 #else
 
 #include <asm/smplock.h>
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/spinlock.h linux-openmosix/include/linux/spinlock.h
--- linux/include/linux/spinlock.h	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/include/linux/spinlock.h	2004-02-05 10:51:27.000000000 +0100
@@ -149,6 +149,10 @@
 #define write_lock(lock)	(void)(lock) /* Not "unused variable". */
 #define write_unlock(lock)	do { } while(0)
 
+#ifdef CONFIG_MOSIX
+#define	can_read_lock(rw)	(1)
+#endif /* CONFIG_MOSIX */
+
 #endif /* !SMP */
 
 /* "lock on reference count zero" */
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/wait.h linux-openmosix/include/linux/wait.h
--- linux/include/linux/wait.h	2003-08-25 13:44:44.000000000 +0200
+++ linux-openmosix/include/linux/wait.h	2004-02-05 10:51:27.000000000 +0100
@@ -190,6 +190,21 @@
 	return !list_empty(&q->task_list);
 }
 
+#ifdef CONFIG_MOSIX
+#if BITS_PER_LONG == 32
+#define	KERNEL_ADDRESS_BIT	0x80000000
+#else
+#error please fill in: use a bit that is always set in kernel addresses.
+#endif
+#define	IN_MOSIX_CONTEXT(p)	(!(((unsigned long) (p)) & KERNEL_ADDRESS_BIT))
+#define	MOSIX_CONTEXT(p)	((struct task_struct *)\
+				(((unsigned long) (p)) & ~KERNEL_ADDRESS_BIT))
+#define	NORMAL_CONTEXT(p)	((struct task_struct *)\
+				(((unsigned long) (p)) | KERNEL_ADDRESS_BIT))
+
+extern void adjust_task_mosix_context(struct task_struct **);
+#endif /* CONFIG_MOSIX */
+
 static inline void __add_wait_queue(wait_queue_head_t *head, wait_queue_t *new)
 {
 #if WAITQUEUE_DEBUG
@@ -200,6 +215,9 @@
 	if (!head->task_list.next || !head->task_list.prev)
 		WQ_BUG();
 #endif
+#ifdef CONFIG_MOSIX
+	adjust_task_mosix_context(&new->task);
+#endif /* CONFIG_MOSIX */
 	list_add(&new->task_list, &head->task_list);
 }
 
@@ -217,6 +235,9 @@
 	if (!head->task_list.next || !head->task_list.prev)
 		WQ_BUG();
 #endif
+#ifdef CONFIG_MOSIX
+	adjust_task_mosix_context(&new->task);
+#endif /* CONFIG_MOSIX */
 	list_add_tail(&new->task_list, &head->task_list);
 }
 
diff -Naur --exclude=CVS --exclude=configs linux/include/net/sock.h linux-openmosix/include/net/sock.h
--- linux/include/net/sock.h	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/include/net/sock.h	2004-02-05 10:51:28.000000000 +0100
@@ -560,6 +560,9 @@
 	/* Hole of 3 bytes. Try to pack. */
 	int			route_caps;
 	int			proc;
+#ifdef CONFIG_MOSIX
+	struct task_struct	*owner;
+#endif /* CONFIG_MOSIX */
 	unsigned long	        lingertime;
 
 	int			hashent;
